Boomkinator = LibStub("AceAddon-3.0"):NewAddon("Boomkinator", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")

local L    = LibStub("AceLocale-3.0"):GetLocale("Boomkinator")

-- localize functions
local UnitGUID = _G.UnitGUID
local UnitExists = _G.UnitExists
local UnitBuff = _G.UnitBuff
local UnitDebuff = _G.UnitDebuff
local UnitClass = _G.UnitClass
local UnitPower = _G.UnitPower
local GetSpellInfo = _G.GetSpellInfo
local GetSpellCooldown = _G.GetSpellCooldown
local GetSpellTexture = _G.GetSpellTexture
local UnitHealth = _G.UnitHealth
local UnitHealthMax = _G.UnitHealthMax
local sformat = string.format
--
local settings
local updater = ""

local spells = {}
local icons = {}
local buttons = {}
local timers = {}
local stacks = {}

local wreak = false
local implode = false
local blaze = false
local burn = false
local slice = false
local immolateTable = {}

Boomkinator.Credits1 = "Boomkinator - by Aznamir (Lightbringer US)";

-------------------------------------------------------------------
-- Spell Settings
-------------------------------------------------------------------
Boomkinator.OwlSpells = {
	[1] = 8921,		-- Moonfire
	[2] = 93402,	-- Sunfire
	[3] = 194153,	-- Lunar Strike
	[4] = 5176,		-- Solar Wrath
	[5] = 78674,	-- Starsurge
	[6] = 191034,	-- Starfall
	[7] = 202767,	-- Artifact (New Moon)
	[12]= 164547,	-- lunar empowerment
	[13]= 164545,	-- solar empowerment
}
Boomkinator.RestoSpells = {
	[1] = 774,		-- rejuv
	[2] = 8936,		-- regrow
	[3] = 188550,	-- life bloom
	[4] = 5185,		-- healing touch
	[5] = 18562,	-- swift mend
	[6] = 48438,	-- wild growth
	[7] = 102342,	-- iron bark
	[8] = 197721,	-- flourish
	[9] = 740,		-- tranq
}
Boomkinator.CombatSpells = {
	[1] = 1766, 	-- kick
	[2] = 13877, 	-- blade flurry
	[3] = 13750,	-- #8 adrenaline rush,
	[4] = 195627,  	--opportunity
	[5] = 212198,   --crimson-vial
	[6] = 199804,	--between-the-eyes
	[7] = 193316, 	-- roll the bones
	[8] = 5171,		-- slice and dice
	[9] = 202665,   -- curse of dreadblades
	[11]= 193359, 	-- true-bearing
	[12]= 193357, 	-- shark-infested-waters
	[13]= 199603, 	-- jolly-roger
	[14]= 193358, 	-- grand-melee
	[15]= 193356, 	-- broadsides
	[16]= 199600, 	-- buried-treasure
}
Boomkinator.AffSpells = {
	[1] = 980,		-- agony
	[2] = 172, 		-- corruption
	[3] = 63106, 	-- siphon life
	[4] = 689, 		-- drain life
	[5] = 30108, 	-- unstable affliction
	[6] = 48181, 	-- haunt
	[7] = 18540, 	-- doomguard
	[8] = 111897, 	-- grimoire: felhunter
	[9] = 216695,	-- tormented souls,
	[10]= 199440,	-- deadwind hardvester
}
Boomkinator.DestSpells = {
	[1] = 348,		-- immolate
	[2] = 17877,	-- shadow burn
	[3] = 116858,	-- chaos bolt
	[4] = 29722,	-- incinerate
	[5] = 17962,	-- conflagrate
	[6] = 80240,	-- havoc	
	[7] = 18540, 	-- doomguard
	[8] = 111859, 	-- grimoire: imp
	[9] = 196586, 	-- artifact dimensional rift
	[10]= 196414,  	-- eradication	
}
Boomkinator.DemoSpells = {
	[1] = 603, 		-- doom
	[2] = 104316, 	-- call dreadstalkers
	[3] = 119898, 	-- command demon
	[4] = 196657,	-- shadow bolt
	[5] = 105174,	-- HoG
	[6] = 193396, 	-- demonic empowerment
	[7] = 196277, 	-- implosion
	[8] = 211717, 	-- artifact
	[9] = 18540, 	-- doomguard
	[10]= 111898,	-- grimoire: felguard
	[11]= 205145,	-- demonic calling
	[12]= 188857, 	-- demon-rush
}
Boomkinator.HavocSpells = {
	[1] = 183752,	-- consume magic
	[2] = 195072,	-- fel rush
	[3] = 198013, 	-- eye beam
	[4] = 162794,   -- chaos strike
	[5] = 185123,   -- throw glaive
	[6] = 188499,	-- blade dance
	[7] = 191427,	-- meta
	[8] = 201467,	-- artifact
	[9] = 198793,	-- veng retreat
}
Boomkinator.VengeanceSpells = {
	[1] = 183752,	--consume magic
	[2]	= 189110,	--infernal-strike
	[3] = 204596, 	--sigil-of-flame
	[4]	= 203783,	--shear
	[5] = 203798, 	--soul-cleave
	[6] = 178740,	--immolation-aura
	[7] = 191427,	-- meta
	[8] = 203720,	--demon-spikes
	[9] = 218256, 	--empower-wards
	[11] = 203981,	-- soul fragments
}
-------------------------------------------------------------------
-- Interface settings
-------------------------------------------------------------------
Boomkinator.options =
{
	type = "group",
	name = "Boomkinator",
	args = {
		desc = {
			type = "description",
			order = 0,
			name = L["MOVE_DESC"],
		},
		reset = {
			type = "execute",
			order = 1,
			name = L["RESET"],
			desc = L["RESET_DESC"],
			func = function() Boomkinator:Reset() end,
		},
		show = {
			type = "execute",
			order = 2,
			name = L["SHOW"],
			desc = L["SHOW_DESC"],
			func = function() Boomkinator:ShowLayout() end,
		},
		hide = {
			type = "execute",
			order = 3,
			name = L["HIDE"],
			desc = L["HIDE_DESC"],
			func = function() Boomkinator:HideLayout() end,
		},
		lock = {
			type = "execute",
			order = 4,
			name = L["LOCK"],
			desc = L["LOCK_DESC"],
			func = function() 
					settings.locked = true
					Boomkinator:LockLayout() 
				end,
		},
		unlock = {
			type = "execute",
			order = 5,
			name = L["UNLOCK"],
			desc = L["UNLOCK_DESC"],
			func = function()
					settings.locked = false
					Boomkinator:UnlockLayout()
				end,
		},
		scale = {
			type = "range",
			order = 6,
			name = L["BSC"],
			desc = L["BSC_DESC"],
			min = 0.4,
			max = 1.5,
			step = 0.05,
			get = function(info) return settings.buffscale end,
			set = function(info, val)
					settings.buffscale = val
					Boomkinator:UpdateLayout()
				end,
		},
		fontscale = {
			type = "range",
			order = 7,
			name = "Font Scale",
			desc = "Scale of timer fonts", 
			min = 8,
			max = 14,
			step = 1,
			get = function(info) return settings.fontscale end,
			set = function(info, val)
					settings.fontscale = val
					Boomkinator:UpdateLayout()
				end,
		},
		rows = {
			type = "range",
			order = 8,
			name = "Display Rows",
			desc = "Number of button rows", 
			min = 1,
			max = 3,
			step = 1,
			get = function(info) return settings.rows end,
			set = function(info, val)
					settings.rows = val
					Boomkinator:UpdateLayout()
				end,
		},
	},
}
-------------------------------------------------------------------
-- Default Settings
-------------------------------------------------------------------
Boomkinator.defaults = {
	profile = {
		buffscale = 0.9,
		fontscale = 10,
		locked = false,
		disabled = false,
		rows = 3
	}
}
-------------------------------------------------------------------
-- Ace Framework Events
-------------------------------------------------------------------
function Boomkinator:OnInitialize()
	--self:Print("OnInitialize")
	DEFAULT_CHAT_FRAME:AddMessage("|cff33ff99"..Boomkinator.Credits1.."|r")
	self.db = LibStub("AceDB-3.0"):New("BoomkinatorDB", Boomkinator.defaults, "Default")
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileReset", "OnProfileChanged")
	settings = self.db.profile
	Boomkinator.options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)

	LibStub("AceConfig-3.0"):RegisterOptionsTable("Boomkinator", Boomkinator.options, "boom")
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Boomkinator", "Boomkinator")

	self:UpdateLayout()
end

function Boomkinator:OnProfileChanged()
	--self:Print("OnProfileChanged")
	settings = self.db.profile
	self:UpdateLayout()
end

function Boomkinator:OnEnable()
	--self:Print("OnEnable")
	settings.disabled = false
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	--self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
	self:RegisterEvent("PLAYER_TALENT_UPDATE")
	self:RegisterEvent("ENCOUNTER_START")
	self:RegisterEvent("ENCOUNTER_END")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:UpdateLayout()
end

function Boomkinator:OnDisable()
	--self:Print("OnDisable")
	-- events
	settings.disabled = true
	self:UpdateLayout()
end

function Boomkinator:MediaUpdate()

end
-------------------------------------------------------------------
-- Service Functions
-------------------------------------------------------------------
function Boomkinator:FormatTime(time)
	if not time or time < 0 or time == 9999 then
		return ""
	end
	local mins = floor(time / 60)
	local secs = time - (mins * 60)
	return sformat("%d:%02d", mins, secs)
end

function Boomkinator:FormatShort(time)
	if not time or time < 0 or time == 9999 then
		return ""
	end
	return sformat("%0.1f", time)
end

function Boomkinator:ReadableNumber(num, places)
    local ret
    local placeValue = ("%%.%df"):format(places or 0)
    if not num then
        return 0
    elseif num >= 1000000000000 then
        ret = placeValue:format(num / 1000000000000) .. " T" -- trillion
    elseif num >= 1000000000 then
        ret = placeValue:format(num / 1000000000) .. " B" -- billion
    elseif num >= 1000000 then
        ret = placeValue:format(num / 1000000) .. " M" -- million
    elseif num >= 1000 then
        ret = placeValue:format(num / 1000) .. "K" -- thousand
    else
        ret = num -- hundreds
    end
    return ret
end
-------------------------------------------------------------------
-- Command Prompt Response
-------------------------------------------------------------------
function Boomkinator:Reset()
	local h = _G["BoomkinatorFrame"]
	h:ClearAllPoints()
	h:SetPoint("CENTER", "UIParent", "CENTER", 0, 0)
	--self:UpdateLayout()
end

function Boomkinator:Debug()
	self:Print("Spells:")
	for i = 1, 16 do
		self:Print("  " .. i .. " = " .. (spells[i] or ""))
	end
	self:Print("Icons:")
	for i = 1, 16 do
		self:Print("  " .. i .. " = " .. (icons[i] or ""))
	end

end

-------------------------------------------------------------------
-- Internal Functions
-------------------------------------------------------------------

-------------------------------------------------------------------
-- External Event Handling
------------------------------------------------------------------
function Boomkinator:PLAYER_REGEN_ENABLED()
	--self:Print("Regen Enabled")
	self:CancelTimer(self.UpdateTimer, true)
	self:HideLayout()
end

function Boomkinator:PLAYER_REGEN_DISABLED()
	--self:Print("Regen Disabled")

	if updater == "" then
		--self:Print("Entered combat without settings, trying to fix UI")
		self:UpdateLayout()
	end
	
	if updater ~= "" then
		--self:Print(updater)
		self.UpdateTimer = self:ScheduleRepeatingTimer(updater, 0.1)
		self:ShowLayout()
	end
end

function Boomkinator:ACTIVE_TALENT_GROUP_CHANGED()
	self:UpdateLayout()
end

function Boomkinator:PLAYER_TALENT_UPDATE()
	self:UpdateLayout()
end

function Boomkinator:ENCOUNTER_START()
	immolateTable = {}
end

function Boomkinator:ENCOUNTER_END()
	immolateTable = {}
end

function Boomkinator:COMBAT_LOG_EVENT_UNFILTERED(event, ...)
	local sourceGUID = select(4, ...)
	if sourceGUID == UnitGUID("player") and updater == "ButtonsDestructUpdate" then
		local SAR = "SPELL_AURA_REMOVED"
        local SAA = "SPELL_AURA_APPLIED"
        local SARe = "SPELL_AURA_REFRESH"
        local SD = "SPELL_DAMAGE"
        local ImmolateCastID = 348
        local ImmolateDoTID = 157736
        local ConflagID = 17962
		--local destGUID = select(8, ...)
        --local subevent = select(2, ...)
        --local spellid = select(12, ...)
		
		local _, subevent, _, _, _, _, _, destGUID, _, _, _, spellid = ...
		if spellid == ImmolateDoTID and (subevent == SAA or subevent == SARe) then
			immolateTable[destGUID] = 1
		elseif spellid == ImmolateDoTID and  subevent == SAR then
			immolateTable[destGUID] = nil
		elseif spellid == ConflagID and subevent == SD then
            if immolateTable[destGUID] ~= nil then
                immolateTable[destGUID] = immolateTable[destGUID] * 1.6
            end
		end
	end
end
-------------------------------------------------------------------
-- Internal Functions
-------------------------------------------------------------------

function Boomkinator:CheckTalents()
	local class = select(2, UnitClass("player"))
	-- druid
	if class == "DRUID" and GetSpecialization() == 1 then -- moonkin
		updater = "ButtonsOwlUpdate"
	elseif class == "DRUID" and GetSpecialization() == 4 then -- resto
		updater = "ButtonsRestoUpdate"
	-- rogue
	elseif class == "ROGUE" and  GetSpecialization() == 2 then -- rogue combat
		updater = "ButtonsCombatUpdate"
	-- warlock
	elseif class == "WARLOCK" and GetSpecialization() == 1 then -- affliction
		updater = "ButtonsAfflictionUpdate"
	elseif class == "WARLOCK" and GetSpecialization() == 2 then -- demonology
		updater = "ButtonsDemonologyUpdate"
	elseif class == "WARLOCK" and GetSpecialization() == 3 then -- destruction
		updater = "ButtonsDestructUpdate"
	elseif class == "DEMONHUNTER" and GetSpecialization() == 1 then -- Havoc
		updater = "ButtonsHavocUpdate"
	elseif class == "DEMONHUNTER" and GetSpecialization() == 2 then -- Vengeance
		updater = "ButtonsVengeanceUpdate"				
	else
		updater = ""
	end
end

function Boomkinator:DoTheThing(thing, slot, ...)
-- thing, slot, parameters
-- 1, x, power
-- 2, x, target, spell, coloring_method(1, -1, 0), show_stacks(1, -1), stacks_max
-- 3, x, target, spell, coloring_method(1, -1, 0)
-- 4, x, spell
-- 5, x, spell, power, powerlimit
-- 6, x, spell, condition,
-- 7, x, spell, duration(-1 for long)
	local target, spell, power, powerlimit, condition, method, show_stacks, shorttimer, stacks_max
	local start, duration, expire
	local buffName, buffCount, buffDuration, buffExpire
	
	-- power check
	-- 1, x, power
	if thing == 1 then
		power = select(1, ...)
		stacks[slot]:SetText("x"..(power or "0"))
	-- self buff expiration
	-- 2, x, target, spell, method, shows tacks
	elseif thing == 2 then
		target = select (1, ...)
		spell = select(2, ...)
		method = select(3, ...)
		show_stacks = select(4, ...)
		stacks_max = select(5, ...)
		spellName = GetSpellInfo(spell)
		buffName, _, _, buffCount, _, buffDuration, buffExpire = UnitBuff(target, spellName)
		if buffName and buffExpire then
			expire = buffExpire - GetTime()
			timers[slot]:SetText(Boomkinator:FormatShort(expire))
			-- stack counts
			if show_stacks == 1 then
				if buffCount then
					stacks[slot]:SetText("x" .. buffCount)
					if stacks_max and stacks_max > 0 then
					-- color stacks
						if buffCount == stacks_max then
							stacks[slot]:SetTextColor(1, 0, 0, 1)
						else
							stacks[slot]:SetTextColor(0, 1, 0, 1)
						end
					end
				else
					stacks[slot]:SetText("")
				end
			end
			-- highlight method
			if method == 1 then
				buttons[slot]:SetVertexColor(1, 1, 1, 0.75)
			elseif method == -1 then
				buttons[slot]:SetVertexColor(1, 1, 1, 0.25)
			end
		else
			if show_stacks == 1 then
				stacks[slot]:SetText("")
			end
			if method == 1 then 
				buttons[slot]:SetVertexColor(1, 1, 1, 0.25)
			elseif method == -1 then
				buttons[slot]:SetVertexColor(1, 1, 1, 0.75)
			end
			timers[slot]:SetText("")
		end
		return buffCount
	 -- debuff on target
	 -- 3, x, target, spell, method
	elseif thing == 3 then
		target = select (1, ...)
		spell = select(2, ...)
		method = select(3, ...)
		if UnitExists(target) and spell then
			spellName = GetSpellInfo(spell)
			_, _, _, _, _, buffDuration, buffExpire = UnitDebuff(target, spellName, nil, "PLAYER")
			if buffExpire then
				expire = buffExpire - GetTime()
				timers[slot]:SetText(Boomkinator:FormatShort(expire))
				if method == 1 then
					buttons[slot]:SetVertexColor(1, 1, 1, 0.3)
				elseif method == -1 then
					buttons[slot]:SetVertexColor(1, 1, 1, 0.75)
				end
			else
				timers[slot]:SetText("")
				if method == 1 then
					buttons[slot]:SetVertexColor(1, 1, 1, 0.75)
				elseif method == -1 then
					buttons[slot]:SetVertexColor(1, 1, 1, 0.3)
				end
			end
		else
			timers[slot]:SetText("")
			if method == 1 then
				buttons[slot]:SetVertexColor(1, 1, 1, 0.3)
			elseif method == -1 then
				buttons[slot]:SetVertexColor(1, 1, 1, 0.75)
			end
		end
	-- simple cooldown
	-- 4, x, spell, shorttimer
	elseif thing == 4 then
		spell = select(1, ...)
		shorttimer = select(2, ...)
		spellName = GetSpellInfo(spell)
		start, duration = GetSpellCooldown(spellName)
		if start then
			if start == 0 or (start > 0 and duration < 1.5 ) then
				timers[slot]:SetText("")
				buttons[slot]:SetVertexColor(1, 1, 1, 0.75)
			else
				-- on cooldown
				expire = start + duration - GetTime()
				if shorttimer == 1 then
					timers[slot]:SetText(Boomkinator:FormatShort(expire))
				else
					timers[slot]:SetText(Boomkinator:FormatTime(expire))
				end
				buttons[slot]:SetVertexColor(1, 1, 1, 0.3)
			end
		else
			timers[slot]:SetText("NA")
			buttons[slot]:SetVertexColor(1, 1, 1, 0.3)
		end
	-- powered cooldown
	-- 5, x, spell, power, powerlimit
	elseif thing == 5 then
		spell = select(1, ...)
		power = select(2, ...)
		powerlimit = select(3, ...)
		spellName = GetSpellInfo(spell)
		start, duration = GetSpellCooldown(spellName)
		if power >= powerlimit then
			if start then
				if start == 0 or (start > 0 and duration < 1.5 ) then
					timers[slot]:SetText("")
					buttons[slot]:SetVertexColor(1, 1, 1, 0.75)
				else
					-- on cooldown
					expire = start + duration - GetTime()
					timers[slot]:SetText(Boomkinator:FormatTime(expire))
					buttons[slot]:SetVertexColor(1, 1, 1, 0.3)
				end
			else
				timers[slot]:SetText("NA")
				buttons[slot]:SetVertexColor(1, 1, 1, 0.3)
			end
		else
			buttons[slot]:SetVertexColor(1, 1, 1, 0.3)
			if start then
				if start == 0 or (start > 0 and duration < 1.5 ) then
					timers[slot]:SetText("")
				else
					-- on cooldown
					expire = start + duration - GetTime()
					timers[slot]:SetText(Boomkinator:FormatTime(expire))
				end
			else
				timers[slot]:SetText("NA")
			end
		end		
	-- conditional coodown
	-- 6, x, spell, condition, shorttimer
	elseif thing == 6 then 
		spell = select(1, ...)
		condition = select(2, ...)
		shorttimer = select(3, ...)
		spellName = GetSpellInfo(spell)
		start, duration = GetSpellCooldown(spellName)
		if start then
			if (start == 0 or (start > 0 and duration < 1.5 )) then
				timers[slot]:SetText("")
				if condition then
					buttons[slot]:SetVertexColor(1, 1, 1, 0.75)
				else
					buttons[slot]:SetVertexColor(1, 1, 1, 0.5)
				end
			else
				-- on cooldown
				expire = start + duration - GetTime()
				if shorttimer == 1 then 
					timers[slot]:SetText(Boomkinator:FormatShort(expire))
				else
					timers[slot]:SetText(Boomkinator:FormatTime(expire))
				end
				buttons[slot]:SetVertexColor(1, 1, 1, 0.3)
			end
		else
			timers[slot]:SetText("NA")
			buttons[slot]:SetVertexColor(1, 1, 1, 0.3)
		end
	-- rechargeable spell
	-- 7, x, spell, duration(1 for long)		
	elseif thing == 7 then
		spell = select(1, ...)
		shorttimer = select(2, ...)
		spellName = GetSpellInfo(spell)
		buffCount, _, _, _ = GetSpellCharges(spellName)
		if buffCount then
			if  buffCount > 0 then
				stacks[slot]:SetText("x" .. buffCount)
				timers[slot]:SetText("")
				if buffCount > 2 then
					buttons[slot]:SetVertexColor(1, 1, 1, 1)
				elseif buffCount == 2 then
					buttons[slot]:SetVertexColor(1, 1, 1, 0.75)			
				elseif buffCount == 1 then			
					buttons[slot]:SetVertexColor(1, 1, 1, 0.50)
				end
			else
				stacks[slot]:SetText("")
				buttons[slot]:SetVertexColor(1, 1, 1, 0.3)
				--check cooldown for next
				start, duration = GetSpellCooldown(spellName)
				if start then
					if start == 0 or (start > 0 and duration < 1.5 ) then
						timers[slot]:SetText("")
					else
						expire = start + duration - GetTime()
						if shorttimer == 1 then
							timers[slot]:SetText(Boomkinator:FormatTime(expire))
						else
							timers[slot]:SetText(Boomkinator:FormatShort(expire))
						end
					end
				end
			end -- buff count
		end	-- buff exists
	end -- if thing
end -- do the thing
-------------------------------------------------------------------
-- Buff UI Setup
-------------------------------------------------------------------
function Boomkinator:UpdateLayout()
	--self:Print("Update Layout")
	local spellName, spellIcon, spellSelected, spellID
	
	self:CheckTalents()
	if updater == "ButtonsOwlUpdate" then
		spells = Boomkinator.OwlSpells
		icons = {
			[1] = select(3, GetSpellInfo(spells[1])),  	-- (button 1)	moonfire 		
			[2] = nil, 									-- (button 2)	dynamic
			[3] = select(3, GetSpellInfo(spells[2])),	-- (button 3)	sunfire 			
			[4] = select(3, GetSpellInfo(spells[3])), 	-- (button 4)	lunar strike 	
			[5] = select(3, GetSpellInfo(spells[5])), 	-- (button 5)	starsurge 
			[6] = select(3, GetSpellInfo(spells[4])), 	-- (button 6)   solar wrath
			[7] = select(3, GetSpellInfo(spells[6])), 	-- (button 7)	starfall
			[8] = nil,									-- (button 8) 	dynamic
			[9] = select(3, GetSpellInfo(spells[7])), 	-- (button 9) 	artifact
			[10] = nil,									-- empty
		}
		-- talent customizations
		-- alignments vs incarnation
		spellSelected = select(4, GetTalentInfo(5, 2, 1))
		if spellSelected then
			spells[8] = 102560 -- incarnation
			icons[8] = select(3, GetSpellInfo(spells[8]))
		else
			spells[8] = 194223 -- alignment
			icons[8] = select(3, GetSpellInfo(spells[8]))
		end
		-- flare
		spellSelected = select(4,  GetTalentInfo(5, 3, 1))
		if spellSelected then
			spells[9] = 202347
			icons[2] = select(3, GetSpellInfo(spells[9]))
		else
			spells[9] = nil
			icons[2] = nil
		end
	elseif updater == "ButtonsRestoUpdate" then
		spells = Boomkinator.RestoSpells
		icons = {
			[1] = select(3, GetSpellInfo(spells[1])),
			[2] = select(3, GetSpellInfo(spells[2])),
			[3] = select(3, GetSpellInfo(spells[3])),
			[4] = select(3, GetSpellInfo(spells[4])),
			[5] = select(3, GetSpellInfo(spells[5])),
			[6] = select(3, GetSpellInfo(spells[6])),
			[7] = select(3, GetSpellInfo(spells[7])),
			[8] = select(3, GetSpellInfo(spells[8])),
			[9] = select(3, GetSpellInfo(spells[9])),
			[10]=  select(3, GetSpellInfo(spells[10])),
		}
	elseif updater == "ButtonsCombatUpdate" then
		spells = Boomkinator.CombatSpells
		icons = {
			[1] = select(3, GetSpellInfo(spells[1])),
			[2] = select(3, GetSpellInfo(spells[2])),
			[3] = select(3, GetSpellInfo(spells[3])),
			[4] = select(3, GetSpellInfo(spells[4])),
			[5] = select(3, GetSpellInfo(spells[5])),
			[6] = select(3, GetSpellInfo(spells[6])),
			[7] = nil, 									-- dynamic
			[8] = nil,									-- dynamic
			[9] = select(3, GetSpellInfo(spells[9])),
			[10]= nil,									-- empty
			[11]= select(3, GetSpellInfo(spells[11])),	-- bones
			[12]= select(3, GetSpellInfo(spells[12])),
			[13]= select(3, GetSpellInfo(spells[13])),
			[14]= select(3, GetSpellInfo(spells[14])),
			[15]= select(3, GetSpellInfo(spells[15])),
			[16]= select(3, GetSpellInfo(spells[16])),
		}
		-- slice and dice
		slice = select(4, GetTalentInfo(7, 1, 1))
		if slice then
			-- s&d
			icons[7] = select(3, GetSpellInfo(spells[8]))
		else
			-- bones
			icons[7] = select(3, GetSpellInfo(spells[7]))
		end
	elseif updater == "ButtonsAfflictionUpdate" then
		spells = Boomkinator.AffSpells
		icons = {
			[1] = select(3, GetSpellInfo(spells[1])),
			[2] = select(3, GetSpellInfo(spells[2])),
			[3] = select(3, GetSpellInfo(spells[3])),
			[4] = select(3, GetSpellInfo(spells[4])),
			[5] = select(3, GetSpellInfo(spells[5])),
			[6] = nil,
			[7] = select(3, GetSpellInfo(spells[7])),
			[8] = select(3, GetSpellInfo(spells[8])),
			[9] = select(3, GetSpellInfo(spells[9])),
			[10] = nil,
		}
		-- haunt check
		spellSelected = select(4, GetTalentInfo(1, 1, 1))
		if spellSelected then
			icons[6] = select(3, GetSpellInfo(spells[6]))
		else
			spells[6] = nil
			icons[6] = nil
		end
	elseif updater == "ButtonsDemonologyUpdate" then
		spells = Boomkinator.DemoSpells
		icons = {
			[1] = select(3, GetSpellInfo(spells[1])),
			[2] = select(3, GetSpellInfo(spells[2])),
			[3] = select(3, GetSpellInfo(spells[3])),
			[4] = select(3, GetSpellInfo(spells[4])),
			[5] = select(3, GetSpellInfo(spells[5])),
			[6] = select(3, GetSpellInfo(spells[6])),
			[7] = select(3, GetSpellInfo(spells[7])),
			[8] = select(3, GetSpellInfo(spells[8])),
			[9] = select(3, GetSpellInfo(spells[9])),
			[10]=  select(3, GetSpellInfo(spells[10])),
		}
		-- implosion
		implode = select(4, GetTalentInfo(2, 3, 1))
		if not implode then
			icons[7] = nil
		end
	elseif updater == "ButtonsDestructUpdate" then
		spells = Boomkinator.DestSpells
		icons = {
			[1] = select(3, GetSpellInfo(spells[1])),
			[2] = select(3, GetSpellInfo(spells[2])),
			[3] = select(3, GetSpellInfo(spells[3])),
			[4] = select(3, GetSpellInfo(spells[4])),
			[5] = select(3, GetSpellInfo(spells[5])),
			[6] = select(3, GetSpellInfo(spells[6])),
			[7] = select(3, GetSpellInfo(spells[7])),
			[8] = select(3, GetSpellInfo(spells[8])),
			[9] = select(3, GetSpellInfo(spells[9])),
			[10]= nil,
		}
		-- roaring blaze
		blaze = select(4, GetTalentInfo(1, 2, 1))
		-- shadow burn
		burn = select(4, GetTalentInfo(1, 3, 1))
		if not burn then
			icons[2] = nil
		end
		-- wreak havoc
		wreak = select(4, GetTalentInfo(7, 1, 1))
	elseif updater == "ButtonsHavocUpdate" then
		spells = Boomkinator.HavocSpells
		icons = {
			[1] = select(3, GetSpellInfo(spells[1])),
			[2] = select(3, GetSpellInfo(spells[2])),
			[3] = select(3, GetSpellInfo(spells[3])),
			[4] = select(3, GetSpellInfo(spells[4])),
			[5] = select(3, GetSpellInfo(spells[5])),
			[6] = select(3, GetSpellInfo(spells[6])),
			[7] = select(3, GetSpellInfo(spells[7])),
			[8] = select(3, GetSpellInfo(spells[8])),
			[9] = select(3, GetSpellInfo(spells[9])),
			[10]= nil,
		}
	elseif updater == "ButtonsVengeanceUpdate" then
		spells = Boomkinator.VengeanceSpells
		icons = {
			[1] = select(3, GetSpellInfo(spells[1])),
			[2] = select(3, GetSpellInfo(spells[2])),
			[3] = select(3, GetSpellInfo(spells[3])),
			[4] = select(3, GetSpellInfo(spells[4])),
			[5] = select(3, GetSpellInfo(spells[5])),
			[6] = select(3, GetSpellInfo(spells[6])),
			[7] = select(3, GetSpellInfo(spells[7])),
			[8] = select(3, GetSpellInfo(spells[8])),
			[9] = select(3, GetSpellInfo(spells[9])),
			[10]= nil,
		}
	else
		icons = {}
	end
	
	if updater ~= nil then
		bframe = _G["BoomkinatorFrame"]

		for i = 1, 10 do
			buttons[i] = _G["BoomkinatorFrameButton"..i]
			buttons[i]:SetTexture(icons[i])
			buttons[i]:SetVertexColor(1, 1, 1, 1)
			timers[i]  = _G["BoomkinatorFrameTime"..i]
			timers[i]:SetText("")
			timers[i]:SetFont("Fonts\\FRIZQT__.TTF", settings.fontscale)
			stacks[i]  = _G["BoomkinatorFrameStack"..i]
			stacks[i]:SetText("")
			stacks[i]:SetFont("Fonts\\FRIZQT__.TTF", settings.fontscale)
		end
	end
	if settings.rows == 1 then
		buttons[2]:SetPoint("TOPLEFT", buttons[1], "TOPRIGHT", 2, 0)
		buttons[3]:SetPoint("TOPLEFT", buttons[2], "TOPRIGHT", 2, 0)
		buttons[4]:SetPoint("TOPLEFT", buttons[3], "TOPRIGHT", 2, 0)
		buttons[5]:SetPoint("TOPLEFT", buttons[4], "TOPRIGHT", 2, 0)
		buttons[6]:SetPoint("TOPLEFT", buttons[5], "TOPRIGHT", 2, 0)
		buttons[7]:SetPoint("TOPLEFT", buttons[6], "TOPRIGHT", 2, 0)
		buttons[8]:SetPoint("TOPLEFT", buttons[7], "TOPRIGHT", 2, 0)
		buttons[9]:SetPoint("TOPLEFT", buttons[8], "TOPRIGHT", 2, 0)
		buttons[10]:SetPoint("TOPLEFT", buttons[9], "TOPRIGHT", 2, 0)
	elseif settings.rows == 2 then
		buttons[2]:SetPoint("TOPLEFT", buttons[1], "TOPRIGHT", 2, 0)
		buttons[3]:SetPoint("TOPLEFT", buttons[2], "TOPRIGHT", 2, 0)
		buttons[4]:SetPoint("TOPLEFT", buttons[3], "TOPRIGHT", 2, 0)
		buttons[5]:SetPoint("TOPLEFT", buttons[4], "TOPRIGHT", 2, 0)
		buttons[6]:SetPoint("TOPLEFT", buttons[1], "BOTTOMLEFT", 0, -1)
		buttons[7]:SetPoint("TOPLEFT", buttons[6], "TOPRIGHT", 2, 0)
		buttons[8]:SetPoint("TOPLEFT", buttons[7], "TOPRIGHT", 2, 0)
		buttons[9]:SetPoint("TOPLEFT", buttons[8], "TOPRIGHT", 2, 0)
		buttons[10]:SetPoint("TOPLEFT", buttons[9], "TOPRIGHT", 2, 0)
	else
		buttons[2]:SetPoint("TOPLEFT", buttons[1], "TOPRIGHT", 2, 0)
		buttons[3]:SetPoint("TOPLEFT", buttons[2], "TOPRIGHT", 2, 0)
		buttons[4]:SetPoint("TOPLEFT", buttons[1], "BOTTOMLEFT", 0, -1)
		buttons[5]:SetPoint("TOPLEFT", buttons[4], "TOPRIGHT", 2, 0)
		buttons[6]:SetPoint("TOPLEFT", buttons[5], "TOPRIGHT", 2, 0)
		buttons[7]:SetPoint("TOPLEFT", buttons[4], "BOTTOMLEFT", 0, -1)
		buttons[8]:SetPoint("TOPLEFT", buttons[7], "TOPRIGHT", 2, 0)
		buttons[9]:SetPoint("TOPLEFT", buttons[8], "TOPRIGHT", 2, 0)
		buttons[10]:SetPoint("TOPLEFT", buttons[9], "TOPRIGHT", 2, 0)
	end
	
	BoomkinatorFrame:SetScale(settings.buffscale)
	self:HideLayout()

	if settings.locked then
		Boomkinator:LockLayout()
	else
		Boomkinator:UnlockLayout()
	end
end

function Boomkinator:ShowLayout()
	bframe:Show()
end

function Boomkinator:HideLayout()
	bframe:Hide()
end

function Boomkinator:LockLayout()
	bframe:EnableMouse(false)
end

function Boomkinator:UnlockLayout()
	bframe:EnableMouse(true)
end

function Boomkinator:GetSeverityColor(percent)
	if (percent >= 0.5) then
		return (1.0-percent)*2, 1.0, 0.0
	else
		return 1.0, percent*2, 0.0
	end
end
-------------------------------------------------------------------
-- Class Functionality: Warlock Affliction
-------------------------------------------------------------------
function Boomkinator:ButtonsAfflictionUpdate()
	-- soul shards
	Boomkinator:DoTheThing(1, 5, UnitPower("player", 7))
	--check agony
	Boomkinator:DoTheThing(3, 1, "target", spells[1], 1)
	--check corruption
	Boomkinator:DoTheThing(3, 2, "target", spells[2], 1)
	-- siphon
	Boomkinator:DoTheThing(3, 3, "target", spells[3], 1)
	-- check unstable affliction	
	Boomkinator:DoTheThing(3, 5, "target", spells[5], 1)
	--check haunt
	Boomkinator:DoTheThing(3, 6, "target", spells[6], 1)		
	-- doomguard
	Boomkinator:DoTheThing(4, 7, spells[7])	
	-- grimoire
	Boomkinator:DoTheThing(4, 8, spells[8])	
	-- artifact
	local spellName = GetSpellInfo(spells[9])
	local buffCount = select(4, UnitBuff("player", spellName))
	-- collected souls
	Boomkinator:DoTheThing(1, 9, buffCount)
	-- timer
	Boomkinator:DoTheThing(2, 9, "player", spells[10], -1, -1)
end
-------------------------------------------------------------------
-- Class Functionality: Warlock Demonology
-------------------------------------------------------------------
function Boomkinator:ButtonsDemonologyUpdate()
    local power = UnitPower("player" , 7)  -- SPELL_POWER_SOUL_SHARDS
	local spellName, spellIcon, buffName
	-- soul shards
	Boomkinator:DoTheThing(1, 5, power)
	if power >= 3 then
		buttons[5]:SetVertexColor(1, 1, 1, 0.75)
	elseif power >= 2 then
		buttons[5]:SetVertexColor(1, 1, 1, 0.5)
	else
		buttons[5]:SetVertexColor(1, 1, 1, 0.25)	
	end
	-- check doom
	Boomkinator:DoTheThing(3, 1, "target", spells[1], 1)
	-- demon rush
	Boomkinator:DoTheThing(2, 4, "player", spells[12], -1, 1)
	-- dreadstalkers
	-- check demonic calling
	spellName = GetSpellInfo(spells[11])
	buffName, _, _, _, _, _, _ = UnitBuff("player", spellName)
	Boomkinator:DoTheThing(6, 2, spells[2], (power >= 2 or buffName))
	-- artifact
	Boomkinator:DoTheThing(4, 8, spells[8])
	-- custom pet actions
	spellName = GetSpellInfo(spells[3])
	spellIcon = select(3, GetSpellInfo(spells[3]))
	buttons[3]:SetTexture(spellIcon)
	-- pet cooldown
	Boomkinator:DoTheThing(4, 3, spells[3])
	
	-- implosion, demonic empowerment and consumption
	if zpetsplayerguid then -- zpets installed and active
		if zpetspetsneedde > 0 then
			stacks[6]:SetText("x"..zpetspetsneedde)
			stacks[6]:SetTextColor(1, 0.2, 0.2, 1)
			buttons[6]:SetVertexColor(1, 1, 1, 0.75)
		else
			stacks[6]:SetText("")
			buttons[6]:SetVertexColor(1, 1, 1, 0.25)
		end
		
		-- check demonic empowerment		
		Boomkinator:DoTheThing(2, 6, "pet", spells[6], 0, -1)
		
		-- pet and implosion count
		if implode then 
			stacks[7]:SetText("x" .. zpetsdreadcount + zpetstotalimpcount)
			timers[7]:SetText(Boomkinator:ReadableNumber(zpetstotalvalueofimplosion))
			if zpetstotalvalueofimplosion > 200000 then
				buttons[7]:SetVertexColor(1, 1, 1, 0.50)
				timers[7]:SetTextColor(0.4, 1, 0, 1)
			else
				buttons[7]:SetVertexColor(1, 1, 1, 0.25)
				timers[7]:SetTextColor(0.2, 1, 1, 1)
			end
		end
		-- consumption count
		stacks[8]:SetText(Boomkinator:ReadableNumber(zpetsthalkielstotalvalue))
	else
		-- check demonic empowerment		
		Boomkinator:DoTheThing(2, 6, "pet", spells[6], -1)
	end
	
	-- doomguard
	Boomkinator:DoTheThing(4, 9, spells[9])	
	-- grimoire
	Boomkinator:DoTheThing(4, 10, spells[10])	
end
-------------------------------------------------------------------
-- Class Functionality: Warlock Destruction
-------------------------------------------------------------------
function Boomkinator:ButtonsDestructUpdate()
    local power
	local guid

	-- soul shards
	power = UnitPower("player" , 7)  -- SPELL_POWER_SOUL_SHARDS 
	Boomkinator:DoTheThing(1, 4, power)
	if power < 2 then
		buttons[4]:SetVertexColor(1, 1, 1, 0.75)
	elseif power < 4 then
		buttons[4]:SetVertexColor(1, 1, 1, 0.5)
	else
		buttons[4]:SetVertexColor(1, 1, 1, 0.3)	
	end
	--immolate
	Boomkinator:DoTheThing(3, 1, "target", spells[1], 1)
	if blaze then
		guid = UnitGUID("target")
		if immolateTable[guid] ~= nil then
			stacks[1]:SetText("x"..sformat("%0.1f", immolateTable[guid]))
		else
			stacks[1]:SetText("")
		end
	end
	-- chaos bolt
	-- check eradicate
	Boomkinator:DoTheThing(3, 3, "target", spells[10], 0)
	-- has shards to use
	if power >= 2 then
		buttons[3]:SetVertexColor(1, 1, 1, 1)
	else
		buttons[3]:SetVertexColor(1, 1, 1, 0.3)
	end
	
	-- shadowburn
	if UnitHealth("target")/UnitHealthMax("target") < 0.2 and power >= 1 and burn then
		buttons[2]:SetVertexColor(1, 1, 1, 0.75)
	else
		-- hold shadowburn
		buttons[2]:SetVertexColor(1, 1, 1, 0.25)
	end
	-- conflag
	Boomkinator:DoTheThing(7, 5, spells[5])
	-- rift
	Boomkinator:DoTheThing(7, 9, spells[9], 1)
	-- Havoc
	if not wreak then -- on cooldown
		Boomkinator:DoTheThing(4, 6, spells[6])
	else
		Boomkinator:DoTheThing(3, 6, "focus", spells[6], 1)
	end
	-- doomguard
	Boomkinator:DoTheThing(4, 7, spells[7])	
	-- grimoire
	Boomkinator:DoTheThing(4, 8, spells[8])	
	
end
-------------------------------------------------------------------
-- Class Functionality: Rogue Combat
-------------------------------------------------------------------
function Boomkinator:ButtonsCombatUpdate()
	local power
	local dice = 0
	local tb = 0
	local condition = false
	-- combo points
	power = UnitPower("player", 4)
	Boomkinator:DoTheThing(1, 7, power)

	if slice then
		Boomkinator:DoTheThing(2, 7, "player", spells[8], -1, -1)
	else
		buttons[7]:SetVertexColor(1, 1, 1, 0.5)
		-- bone analysis
		for i = 1, 6 do
			spellName = GetSpellInfo(spells[i+10])
			buffName, _, _, _, _, _, buffExpire = UnitBuff("player", spellName)
			if buffName and buffExpire then
				expire = buffExpire - GetTime()
				dice = dice + 1
				if i == 1 then tb = 1 end
				if dice == 1 then
					buttons[8]:SetTexture(icons[i+10])
					buttons[8]:SetVertexColor(1, 1, 1, 0.5)
					timers[8]:SetText(Boomkinator:FormatTime(expire))
				end
			end
		end
		if dice == 0 then
			buttons[8]:SetTexture(nil)
			timers[8]:SetText("")
		else
			if dice > 1 then
				stacks[8]:SetText("+" .. ( dice - 1) )
				stacks[8]:SetTextColor(0, 1, 1, 1)
			else
				stacks[8]:SetText("")
			end
		end
	end
		
	-- kick
	Boomkinator:DoTheThing(4, 1, spells[1], 1)
	-- blade flurry
	Boomkinator:DoTheThing(2, 2, "player", spells[2], -1, -1)
	-- adrenaline rush
	--if (tb == 1 or slice) then condition = true end
	Boomkinator:DoTheThing(6, 3, spells[3], (tb == 1 or slice)) --condition)
	-- opportiunity
	Boomkinator:DoTheThing(2, 4, "player", spells[4], 1, -1)
	-- vial
	Boomkinator:DoTheThing(4, 5, spells[5])
	-- shot
	Boomkinator:DoTheThing(4, 6, spells[6])
	-- blades
	Boomkinator:DoTheThing(4, 9, spells[9])
end
-------------------------------------------------------------------
-- Class Functionality: Druid Moonkin
-------------------------------------------------------------------
function Boomkinator:ButtonsOwlUpdate()
	local power = UnitPower("player", SPELL_POWER_ECLIPSE)
	Boomkinator:DoTheThing(1, 5, power)	
	
	-- starfall
	if power >= 60 then
		buttons[7]:SetVertexColor(1, 1, 1, 0.75)
	else
		buttons[7]:SetVertexColor(1, 1, 1, 0.25)
	end
	
	-- starsurge
	if power >= 40 then
		buttons[5]:SetVertexColor(1, 1, 1, 0.75)
	else
		buttons[5]:SetVertexColor(1, 1, 1, 0.25)
	end
	-- lunar strike
	Boomkinator:DoTheThing(2, 4, "player", spells[12], 0, 1, 3)
	buttons[4]:SetVertexColor(1, 1, 1, 0.3)
	-- solar wrath
	Boomkinator:DoTheThing(2, 6, "player", spells[13], 0, 1, 3)
	buttons[6]:SetVertexColor(1, 1, 1, 0.3)
	-- artifact dynamic icon
	spellName = GetSpellInfo(spells[7])
	spellIcon = GetSpellTexture(spellName)
	buttons[9]:SetTexture(spellIcon)
	-- artifact charges
	Boomkinator:DoTheThing(7, 9, spells[7], -1)
	-- moonfire
	Boomkinator:DoTheThing(3, 1, "target", spells[1], 1)
	-- stellar flare
	Boomkinator:DoTheThing(3, 2, "target", spells[9], 1)
	-- sun fire
	Boomkinator:DoTheThing(3, 3, "target", spells[2], 1)
	-- alignment
	Boomkinator:DoTheThing(4, 8, spells[8])
end
-- resto
function Boomkinator:ButtonsRestoUpdate()
	Boomkinator:DoTheThing(2, 1, "target", spells[1], -1)
	Boomkinator:DoTheThing(2, 2, "target", spells[2], -1)
	Boomkinator:DoTheThing(2, 3, "target", spells[3], -1)
	Boomkinator:DoTheThing(7, 5, spells[5])
	Boomkinator:DoTheThing(4, 6, spells[6], 1)
	Boomkinator:DoTheThing(4, 7, spells[7], -1)
	Boomkinator:DoTheThing(4, 8, spells[8], -1)
	Boomkinator:DoTheThing(4, 9, spells[9], -1)
end
-------------------------------------------------------------------
-- Class Functionality: Demon Hunter Havoc
-------------------------------------------------------------------
function Boomkinator:ButtonsHavocUpdate()
	-- fury
	local power = UnitPower("player", SPELL_POWER_DEMONIC_FURY)
	Boomkinator:DoTheThing(1, 4, power)
	-- consume magic
	Boomkinator:DoTheThing(4, 1, spells[1], 1)
	-- fel rush
	Boomkinator:DoTheThing(7, 2, spells[2])
	-- eye beam
	Boomkinator:DoTheThing(6, 3, spells[3], (power >= 50))
	-- chaos strike
	Boomkinator:DoTheThing(6, 4, spells[4], (power >= 40), 1)
	-- throw glaive
	Boomkinator:DoTheThing(4, 5, spells[5], 1)
	-- blade dance
	Boomkinator:DoTheThing(6, 6, spells[6], (power >= 35), 1)
	-- meta
	Boomkinator:DoTheThing(4, 7, spells[7])
	-- artifact
	Boomkinator:DoTheThing(4, 8, spells[8])
	-- retreat
	Boomkinator:DoTheThing(4, 9, spells[9])
end
-------------------------------------------------------------------
-- Class Functionality: Demon Hunter Vengeance
-------------------------------------------------------------------
function Boomkinator:ButtonsVengeanceUpdate()
	local power = UnitPower("player", SPELL_POWER_PAIN)
	Boomkinator:DoTheThing(1, 4, power)
	buttons[4]:SetVertexColor(1, 1, 1, 0.25)
	-- consume magic
	Boomkinator:DoTheThing(4, 1, spells[1], 1)
	-- infernal strike
	Boomkinator:DoTheThing(7, 2, spells[2])
	-- sigil of flame
	Boomkinator:DoTheThing(4, 3, spells[3], 1)
	-- soul cleave
	Boomkinator:DoTheThing(2, 5, "player", spells[11], 0, 1)
	if power >= 60 then
		buttons[5]:SetVertexColor(1, 1, 1, 0.75)
	elseif power >= 30 then
		buttons[5]:SetVertexColor(1, 1, 1, 0.50)
	else
		buttons[5]:SetVertexColor(1, 1, 1, 0.25)
	end
	-- immolation aura
	Boomkinator:DoTheThing(4, 6, spells[6], 1)
	-- meta
	Boomkinator:DoTheThing(4, 7, spells[7])
	-- demon spikes
	Boomkinator:DoTheThing(7, 8, spells[8])
	-- empower wards
	Boomkinator:DoTheThing(4, 9, spells[9], 1)
end